/*
* Copyright (C) 2005, Pasi P. Liimatainen
* Distributable under GNU General Public License (v2)
* See terms of license at http://www.gnu.org
*/

//
// User.
//
function User(username, tagXmlSource) {
    this.username = username;
    this.mTags = new Tags(tagXmlSource);
}

User.prototype = {
	usersKey: 'delicious.users',
	passwordMgmtHost: 'delicious.mozdev.org',
	username: '',

    //
    // Get the account name for the user.
    //
    getAccountName: function()
    {
        return nsPreferences.copyUnicharPref(this.usersKey + '.' + this.username + ".accountname", "");
    },

    //
    // Set the account name for the user.
    //
    setAccountName: function(aAccountname)
    {
        nsPreferences.setUnicharPref(this.usersKey + '.' + this.username + ".accountname", aAccountname);
    },

    //
    // Get the password for the user.
    //
    getPassword: function()
    {
        var passwordManager = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManager);
        var enumerator = passwordManager.enumerator;
        while (enumerator.hasMoreElements()) {
            var pw = enumerator.getNext().QueryInterface(Components.interfaces.nsIPassword);
            if (pw.host == this.passwordMgmtHost && pw.user == this.username) {
                return pw.password;
            }
        }
        return "";
    },

    //
    // Set the password for the user.
    //
    setPassword: function(aPassword)
    {
        var passwordManager = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManager);
        if (this.getPassword().length > 0) {
          passwordManager.removeUser(this.passwordMgmtHost, this.username);
        }
        passwordManager.addUser(this.passwordMgmtHost, this.username, aPassword);
    },

    //
    // Get the del.icio.us username for the user.
    //
    getUsername: function()
    {
        return this.username;
    },

    //
    // Get tags for the user.
    //
    tags getter : function()
    {
        return this.mTags;
    }
}
